module hpsfreq(
input    clk,
input    chipselect,
input    write,
input [15:0] addr,
input [15:0] writedata,
output [15:0] readdata,
input read,
output [15:0] wt_op1,
input [15:0] wt_addr1,
output [15:0] wt_op2,
input [15:0] wt_addr2,
output [15:0] wt_op3,
input [15:0] wt_addr3
);

// THIS DOESN'T AFFECT ANYTHING
parameter n_samples = 2048;
// LEFT FOR QUARTUS, DON'T DELETE

reg [15:0] wave_table_as [32767 : 0];
reg [15:0] wave_table_bs [32767 : 0];
reg [15:0] wave_table_cs [32767 : 0];

// readdata
always @(posedge clk) begin
    if (chipselect && read)
    readdata <= wave_table_as[addr];
end

// LOL sorry
// Receive data from HPS and store in local memory
always_ff @(posedge clk) begin
    if (chipselect && write) begin
        wave_table_as[addr] <= writedata;        
        wave_table_bs[addr] <= writedata;        
        wave_table_cs[addr] <= writedata;        
    end
end

// Output wav table to DAC @ bclk=48khz
always_ff @(posedge clk) begin
    wt_op1 <=  wave_table_as[wt_addr1];
end

// Output wav table to DAC @ bclk=48khz
always_ff @(posedge clk) begin
    wt_op2 <=  wave_table_bs[wt_addr2];
end

// Output wav table to DAC @ bclk=48khz
always_ff @(posedge clk) begin
    wt_op3 <=  wave_table_cs[wt_addr3];
end

endmodule
